var ABOUT_BLOCK_ID = 'abouts';
var ABOUT_FILE_URI = '/about.xml';

/* ------------------------------------------------------------------------------ */

var About = Class.create();
About.prototype = {
    title: '',
    contents: null,
    getTitle: function() { return this.title; },
    getContents: function() { return this.contents; },
    initialize: function(title, contents) {
        this.title = title;
        this.contents = contents;
    },
    toNode: function() {
        var aboutNode = document.createElement('div');
        var titleNode = document.createElement('h2');
        titleNode.appendChild(document.createTextNode(this.title));
        var contentsNode = document.createElement('div');
        $A(this.contents.childNodes).each(function(child) {
            contentsNode.appendChild(copyNode(child, contentsNode));
        });
        aboutNode.appendChild(titleNode);
        aboutNode.appendChild(contentsNode);
        return aboutNode;
    }
}

/* ------------------------------------------------------------------------------ */

// onload
addEvent(window, 'load', showAbout);

/* ------------------------------------------------------------------------------ */

function showAbout() {
    createLoading();
    showLoading();
    new Ajax.Request(
        ABOUT_FILE_URI,
        {
            method: 'get',
            onSuccess: aboutSuccess,
            onComplete: aboutComplete,
            onFailure: aboutFailure
        }
    );
}

/* ------------------------------------------------------------------------------ */

function aboutSuccess(file) {
    hideLoading();
    addAbouts(file.responseXML.documentElement);
}
function aboutComplete() { }
function aboutFailure() { }

function addAbouts(root) {
    var aboutBlock = $(ABOUT_BLOCK_ID);
    var abouts = $A(root.getElementsByTagName('about'));
    abouts.each(function(about) {
        var titleNode = about.getElementsByTagName('title')[0];
        var contentsNode = about.getElementsByTagName('contents')[0];
        var aboutObj = new About(
            titleNode.firstChild.nodeValue,
            contentsNode);
        aboutBlock.appendChild(aboutObj.toNode());
    });
    removeLoading();
}
